/* 
  This program list juggling patterns in an extremely inefficient
  way.
  
  To do:
  .     Command line setting of the number of balls, period, and maxthrow
  .     filter out cyclic permutations of the same pattern

 */
 #include<stream.h>
 #include<GetOpt.h>

 /*
   Global variable deault values
   */

int NUMBER_BALLS = 3;
int PERIOD = 3;
int MAXTHROW = 5;


int test_pattern(int* pattern){
  int state[PERIOD];
  int timeslot;
  
  if(pattern[0] != MAXTHROW){
    return 0;
  };
  
  int count = 0;
  for(timeslot = 0; timeslot < PERIOD; timeslot++){
    count = count + pattern[timeslot];
  };
  if(count != PERIOD * NUMBER_BALLS){
    return 0;
  };
  
  for(timeslot = 0; timeslot < PERIOD; timeslot++){
    state[timeslot]  = 0;
  };
  
  int landingplace;
  for(timeslot = 0; timeslot < PERIOD; timeslot++){
    landingplace = timeslot + pattern[timeslot];
    while(landingplace >= PERIOD){
      landingplace = landingplace - PERIOD;
    };
    state[landingplace] = 1;
  };

  for(timeslot = 0; timeslot < PERIOD; timeslot++){
    if(state[timeslot] == 0){
      return 0;
    };
    
  };

  return 1;
};

void output_pattern(int* pattern){
  int timeslot;
  for(timeslot = 0; timeslot < PERIOD; timeslot++){
    cout << pattern[timeslot] << " ";
  };
  cout << "\n";
};

int increment_pattern(int* pattern, int timeslot){
  if(timeslot >= PERIOD){
    return 0;
  };
  pattern[timeslot]++;
  if(pattern[timeslot] > MAXTHROW){
    pattern[timeslot] = 1;
    if(!increment_pattern(pattern, timeslot + 1)){
      return 0;
    };
  };
  return 1;
};
     

int main(int argc, char** argv){
  int timeslot;
  int* pattern;
 
  /* read command-line options */
  GetOpt getopt (argc, argv, "b:p:h:");
  int option_char;
  while((option_char = getopt()) != EOF){
    switch(option_char){
    case 'b': NUMBER_BALLS = atoi(getopt.optarg); break;
    case 'p': PERIOD = atoi(getopt.optarg); break;
    case 'h': MAXTHROW = atoi(getopt.optarg); break;
    };
  };
  pattern = new int[PERIOD];
  




  for(timeslot = 0; timeslot < PERIOD; timeslot++){
    pattern[timeslot] = 1;
  };
  
  do{
    if( test_pattern(pattern)){
      output_pattern(pattern);
    };
  }
  while(increment_pattern(pattern, 0));
}





